
#include <windows.h>  
#include "AtThrInp.h" 


HINSTANCE hInst;   // current instance

LPCTSTR lpszAppName  = "MyApp";
LPCTSTR lpszTitle    = "My Application"; 


int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                      LPTSTR lpCmdLine, int nCmdShow)
{
   MSG        msg;
   HWND       hWnd; 
   WNDCLASSEX wc;

   // Register the main application window class.
   //............................................
   wc.style         = CS_HREDRAW | CS_VREDRAW;
   wc.lpfnWndProc   = (WNDPROC)WndProc;       
   wc.cbClsExtra    = 0;                      
   wc.cbWndExtra    = 0;                      
   wc.hInstance     = hInstance;              
   wc.hIcon         = LoadIcon( hInstance, lpszAppName ); 
   wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
   wc.lpszMenuName  = lpszAppName;              
   wc.lpszClassName = lpszAppName;              
   wc.cbSize        = sizeof(WNDCLASSEX);
   wc.hIconSm       = LoadImage( hInstance, lpszAppName, 
                                 IMAGE_ICON, 16, 16,
                                 LR_DEFAULTCOLOR );

   if ( !RegisterClassEx( &wc ) )
      return( FALSE );

   hInst = hInstance; 

   // Create the main application window.
   //....................................
   hWnd = CreateWindow( lpszAppName, 
                        lpszTitle,    
                        WS_OVERLAPPEDWINDOW, 
                        CW_USEDEFAULT, 0, 
                        CW_USEDEFAULT, 0,  
                        NULL,              
                        NULL,              
                        hInstance,         
                        NULL               
                      );

   if ( !hWnd ) 
      return( FALSE );

   ShowWindow( hWnd, nCmdShow ); 
   UpdateWindow( hWnd );         

   while( GetMessage( &msg, NULL, 0, 0) )   
   {
      TranslateMessage( &msg ); 
      DispatchMessage( &msg );  
   }

   return( msg.wParam ); 
}


HANDLE hChildThread     = NULL;  // Child thread
DWORD  dwChildThreadId  = 0;     // Child thread ID
DWORD  dwParentThreadId = 0;     // Parent thread ID
HWND   hChildThreadWnd  = NULL;  // Child thread's window
HWND   hParentThreadWnd = NULL;  // Parent thread's window
BOOL   bAttachedInput   = FALSE; // Status of attached input


// Child thread creates a window and loops until program exits.
//.............................................................
DWORD WINAPI ChildThreadProc( LPVOID lpNoData )
{
   MSG msg;
   HWND hWnd = CreateWindow( lpszAppName, "Child Thread's Window",
                             WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, 0,
                             CW_USEDEFAULT, 0, NULL, NULL, hInst, NULL );
   if ( !hWnd )
      return( FALSE );

   ShowWindow( hWnd, SW_SHOW );
   UpdateWindow( hWnd );

   while (GetMessage( &msg, NULL, 0, 0 ))
   {
      TranslateMessage( &msg );
      DispatchMessage( &msg );
   }

   return( TRUE );
}



LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
   switch( uMsg )  
   {   
      case WM_CREATE:   
              // Set globals and create thread.
              //...............................
              if ( !hChildThread )
              {
                 hParentThreadWnd = hWnd;
                 dwParentThreadId = GetCurrentThreadId();
                 hChildThread = CreateThread( NULL, 0, ChildThreadProc, NULL, 0, &dwChildThreadId );
              }
              else
                 hChildThreadWnd = hWnd;
              break;

      case WM_COMMAND :
              switch( LOWORD( wParam ) )
              {
                 case IDM_TEST :
                       {
                          HDC hDC = GetDC( hWnd );

                          // Toggle attached thread input.
                          //..............................
                          if ( bAttachedInput )
                             AttachThreadInput( dwChildThreadId,
                                                dwParentThreadId, 
                                                !bAttachedInput );
                          else
                             AttachThreadInput( dwChildThreadId,
                                                dwParentThreadId, 
                                                !bAttachedInput );

                          bAttachedInput = !bAttachedInput;

                          // Print Message.
                          //...............
                          TextOut( hDC, 0, 0, bAttachedInput ?
                                   "Input is now Attached  " : 
                                   "Input is now Detached  ", 24);
                          ReleaseDC( hWnd, hDC );

                          // Set active window to opposite window.
                          // Only succeeds if inputs are attached.
                          //......................................
                          if ( hWnd == hParentThreadWnd )
                              SetActiveWindow( hChildThreadWnd );
                          else  
                              SetActiveWindow( hParentThreadWnd );
                        }
                        break;

                 case IDM_ABOUT :
                        DialogBox( hInst, "AboutBox", hWnd, (DLGPROC)About );
                        break;

                 case IDM_EXIT :
                        DestroyWindow( hWnd );
                        break;
              }
              break;
      
      case WM_DESTROY :
              PostQuitMessage(0);
              break;

      default :
            return( DefWindowProc( hWnd, uMsg, wParam, lParam ) );
   }

   return( 0L );
}


LRESULT CALLBACK About( HWND hDlg,           
                        UINT message,        
                        WPARAM wParam,       
                        LPARAM lParam)
{
   switch (message) 
   {
       case WM_INITDIALOG: 
               return (TRUE);

       case WM_COMMAND:                              
               if (   LOWORD(wParam) == IDOK         
                   || LOWORD(wParam) == IDCANCEL)    
               {
                       EndDialog(hDlg, TRUE);        
                       return (TRUE);
               }
               break;
   }

   return (FALSE); 
}
