
#include <windows.h>  
#include "GetPrCls.h" 


HINSTANCE hInst;   // current instance

LPCTSTR lpszAppName  = "MyApp";
LPCTSTR lpszTitle    = "My Application"; 


int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                      LPTSTR lpCmdLine, int nCmdShow)
{
   MSG        msg;
   HWND       hWnd; 
   WNDCLASSEX wc;

   // Register the main application window class.
   //............................................
   wc.style         = CS_HREDRAW | CS_VREDRAW;
   wc.lpfnWndProc   = (WNDPROC)WndProc;       
   wc.cbClsExtra    = 0;                      
   wc.cbWndExtra    = 0;                      
   wc.hInstance     = hInstance;              
   wc.hIcon         = LoadIcon( hInstance, lpszAppName ); 
   wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
   wc.lpszMenuName  = lpszAppName;              
   wc.lpszClassName = lpszAppName;              
   wc.cbSize        = sizeof(WNDCLASSEX);
   wc.hIconSm       = LoadImage( hInstance, lpszAppName, 
                                 IMAGE_ICON, 16, 16,
                                 LR_DEFAULTCOLOR );

   if ( !RegisterClassEx( &wc ) )
      return( FALSE );

   hInst = hInstance; 

   // Create the main application window.
   //....................................
   hWnd = CreateWindow( lpszAppName, 
                        lpszTitle,    
                        WS_OVERLAPPEDWINDOW, 
                        CW_USEDEFAULT, 0, 
                        CW_USEDEFAULT, 0,  
                        NULL,              
                        NULL,              
                        hInstance,         
                        NULL               
                      );

   if ( !hWnd ) 
      return( FALSE );

   ShowWindow( hWnd, nCmdShow ); 
   UpdateWindow( hWnd );         

   while( GetMessage( &msg, NULL, 0, 0) )   
   {
      TranslateMessage( &msg ); 
      DispatchMessage( &msg );  
   }

   return( msg.wParam ); 
}


// Function that wastes CPU time.
//...............................
DWORD GoWasteSomeCPU()
{
   long i, j;
   DWORD dwTicksNow = GetTickCount();

   for ( i = 0; i < 100000; i ++ )
      for ( j = 0; j < 1000; j ++ );

   return( GetTickCount() - dwTicksNow );
}


VOID TestResults( HWND hList )
{
   TCHAR szBuffer[128];
   DWORD dwPrCls = GetPriorityClass( GetCurrentProcess() );

   wsprintf( szBuffer, "Priority Class is %s, Time spent: %ld",
                       (dwPrCls == NORMAL_PRIORITY_CLASS ? "NORMAL" :
                       (dwPrCls == REALTIME_PRIORITY_CLASS ? "REALTIME" :
                       (dwPrCls == HIGH_PRIORITY_CLASS ? "HIGH" : "IDLE" ))),
                       GoWasteSomeCPU() );

   SendMessage( hList, LB_INSERTSTRING, (WPARAM)-1, (LPARAM)szBuffer );
}


LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
   static HWND hList = NULL;
   static UINT uPriorityClass = 0;

   switch( uMsg )  
   {   
      case WM_CREATE :
              // Create list box.
              //.................
              hList  = CreateWindowEx( WS_EX_CLIENTEDGE, "LISTBOX", "", 
                                       LBS_STANDARD | LBS_NOINTEGRALHEIGHT | 
                                       WS_CHILD | WS_VISIBLE,
                                       0, 0, 10, 10,
                                       hWnd, (HMENU)101,
                                       hInst, NULL );
              break;

      case WM_SIZE :
              if ( wParam != SIZE_MINIMIZED )
                 MoveWindow( hList, 0, 0, LOWORD( lParam ), HIWORD( lParam ), TRUE );
              break;

      case WM_INITMENU:
              CheckMenuRadioItem( (HMENU)wParam, IDM_IDLE, IDM_REALTIME, 
                                  uPriorityClass, MF_BYCOMMAND ); 
              break;

      case WM_COMMAND :
              switch( LOWORD( wParam ) )
              {
                 case IDM_IDLE:
                 case IDM_NORMAL:
                 case IDM_HIGH:
                 case IDM_REALTIME:
                        uPriorityClass = LOWORD( wParam );
                        SetPriorityClass( GetCurrentProcess(), 
                                 (uPriorityClass == IDM_IDLE ? IDLE_PRIORITY_CLASS :
                                 (uPriorityClass == IDM_NORMAL ? NORMAL_PRIORITY_CLASS :
                                 (uPriorityClass == IDM_HIGH ? HIGH_PRIORITY_CLASS :
                                                               REALTIME_PRIORITY_CLASS))) );

                        TestResults( hList );
                        break;

                 case IDM_ABOUT :
                        DialogBox( hInst, "AboutBox", hWnd, (DLGPROC)About );
                        break;

                 case IDM_EXIT :
                        DestroyWindow( hWnd );
                        break;
              }
              break;
      
      case WM_DESTROY :
              PostQuitMessage(0);
              break;

      default :
            return( DefWindowProc( hWnd, uMsg, wParam, lParam ) );
   }

   return( 0L );
}


LRESULT CALLBACK About( HWND hDlg,           
                        UINT message,        
                        WPARAM wParam,       
                        LPARAM lParam)
{
   switch (message) 
   {
       case WM_INITDIALOG: 
               return (TRUE);

       case WM_COMMAND:                              
               if (   LOWORD(wParam) == IDOK         
                   || LOWORD(wParam) == IDCANCEL)    
               {
                       EndDialog(hDlg, TRUE);        
                       return (TRUE);
               }
               break;
   }

   return (FALSE); 
}
