
#include <windows.h>  
#include "RegHotKy.h" 


HINSTANCE hInst;   // current instance

LPCTSTR lpszAppName  = "MyApp";
LPCTSTR lpszTitle    = "My Application"; 


int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                      LPTSTR lpCmdLine, int nCmdShow)
{
   MSG        msg;
   HWND       hWnd; 
   WNDCLASSEX wc;

   // Register the main application window class.
   //............................................
   wc.style         = CS_HREDRAW | CS_VREDRAW;
   wc.lpfnWndProc   = (WNDPROC)WndProc;       
   wc.cbClsExtra    = 0;                      
   wc.cbWndExtra    = 0;                      
   wc.hInstance     = hInstance;              
   wc.hIcon         = LoadIcon( hInstance, lpszAppName ); 
   wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
   wc.lpszMenuName  = lpszAppName;              
   wc.lpszClassName = lpszAppName;              
   wc.cbSize        = sizeof(WNDCLASSEX);
   wc.hIconSm       = LoadImage( hInstance, lpszAppName, 
                                 IMAGE_ICON, 16, 16,
                                 LR_DEFAULTCOLOR );

   if ( !RegisterClassEx( &wc ) )
      return( FALSE );

   hInst = hInstance; 

   // Create the main application window.
   //....................................
   hWnd = CreateWindow( lpszAppName, 
                        lpszTitle,    
                        WS_OVERLAPPEDWINDOW, 
                        CW_USEDEFAULT, 0, 
                        CW_USEDEFAULT, 0,  
                        NULL,              
                        NULL,              
                        hInstance,         
                        NULL               
                      );

   if ( !hWnd ) 
      return( FALSE );

   ShowWindow( hWnd, nCmdShow ); 
   UpdateWindow( hWnd );         

   while( GetMessage( &msg, NULL, 0, 0) )   
   {
      TranslateMessage( &msg ); 
      DispatchMessage( &msg );  
   }

   return( msg.wParam ); 
}

#define RESUME_KEY    101
#define SUSPEND_KEY   102
#define TERMINATE_KEY 103

DWORD WINAPI ThreadProc( LPDWORD lpdwData)
{
   TCHAR szBuffer[128];
   HWND  hWnd = (HWND)lpdwData;

   wsprintf( szBuffer, "Starting Thread ID = %lX", GetCurrentThreadId() );
   SetWindowText( hWnd, szBuffer );
   Sleep( 10000 );

   wsprintf( szBuffer, "Thread %lX finished execution", GetCurrentThreadId() );
   SetWindowText( hWnd, szBuffer );

   return( 0 );
}


LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
   static HANDLE hChild = NULL;

   switch( uMsg )  
   {   
      case WM_CREATE:
              RegisterHotKey( hWnd, RESUME_KEY, MOD_ALT, 'R' );
              RegisterHotKey( hWnd, SUSPEND_KEY, MOD_ALT, 'S' );
              RegisterHotKey( hWnd, TERMINATE_KEY, MOD_ALT, 'K' );
              break;

      case WM_DESTROY :
              UnregisterHotKey( hWnd, RESUME_KEY );
              UnregisterHotKey( hWnd, SUSPEND_KEY );
              UnregisterHotKey( hWnd, TERMINATE_KEY );
              PostQuitMessage(0);
              break;

      case WM_HOTKEY:
              {
                 TCHAR szBuffer[128];
                 DWORD dwExitCodeThread = STILL_ACTIVE;

                 lstrcpy( szBuffer, "No Child Thread Running" );
                 if (hChild)
                    GetExitCodeThread(hChild, &dwExitCodeThread);

                 if (dwExitCodeThread==STILL_ACTIVE)
                    switch (wParam)
                    {
                       case SUSPEND_KEY:
                           wsprintf( szBuffer, "Suspending thread %lX", hChild );
                           SuspendThread( hChild );
                           break;

                       case RESUME_KEY:
                           wsprintf( szBuffer, "Resuming thread %lX", hChild );
                           ResumeThread( hChild );
                           break;

                       case TERMINATE_KEY:
                           wsprintf( szBuffer, "Terminating thread %lX", hChild );
                           TerminateThread( hChild, FALSE );
                           hChild = NULL;
                           break;
                    }

                 SetWindowText( hWnd, szBuffer );
              }
              break;

      case WM_COMMAND :
              switch( LOWORD( wParam ) )
              {
                 case IDM_TEST:
                        { 
                           // Start a thread. Only one thread at at time.
                           //............................................
                           DWORD dwExitCodeThread;
                           DWORD dwChild;

                           if (hChild)
                              GetExitCodeThread( hChild, &dwExitCodeThread );

                           if (dwExitCodeThread!=STILL_ACTIVE)
                              hChild = CreateThread( NULL, 0, ThreadProc, hWnd, 0, &dwChild );
                        }
                        break;

                 case IDM_ABOUT :
                        DialogBox( hInst, "AboutBox", hWnd, (DLGPROC)About );
                        break;

                 case IDM_EXIT :
                        DestroyWindow( hWnd );
                        break;
              }
              break;
      

      default :
            return( DefWindowProc( hWnd, uMsg, wParam, lParam ) );
   }

   return( 0L );
}


LRESULT CALLBACK About( HWND hDlg,           
                        UINT message,        
                        WPARAM wParam,       
                        LPARAM lParam)
{
   switch (message) 
   {
       case WM_INITDIALOG: 
               return (TRUE);

       case WM_COMMAND:                              
               if (   LOWORD(wParam) == IDOK         
                   || LOWORD(wParam) == IDCANCEL)    
               {
                       EndDialog(hDlg, TRUE);        
                       return (TRUE);
               }
               break;
   }

   return (FALSE); 
}
