
#include <windows.h>  
#include <excpt.h>
#include "SetUnHEx.h" 


HINSTANCE hInst;   // current instance

LPCTSTR lpszAppName  = "MyApp";
LPCTSTR lpszTitle    = "My Application"; 


int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                      LPTSTR lpCmdLine, int nCmdShow)
{
   MSG        msg;
   HWND       hWnd; 
   WNDCLASSEX wc;

   // Register the main application window class.
   //............................................
   wc.style         = CS_HREDRAW | CS_VREDRAW;
   wc.lpfnWndProc   = (WNDPROC)WndProc;       
   wc.cbClsExtra    = 0;                      
   wc.cbWndExtra    = 0;                      
   wc.hInstance     = hInstance;              
   wc.hIcon         = LoadIcon( hInstance, lpszAppName ); 
   wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
   wc.lpszMenuName  = lpszAppName;              
   wc.lpszClassName = lpszAppName;              
   wc.cbSize        = sizeof(WNDCLASSEX);
   wc.hIconSm       = LoadImage( hInstance, lpszAppName, 
                                 IMAGE_ICON, 16, 16,
                                 LR_DEFAULTCOLOR );

   if ( !RegisterClassEx( &wc ) )
      return( FALSE );

   hInst = hInstance; 

   // Create the main application window.
   //....................................
   hWnd = CreateWindow( lpszAppName, 
                        lpszTitle,    
                        WS_OVERLAPPEDWINDOW, 
                        CW_USEDEFAULT, 0, 
                        CW_USEDEFAULT, 0,  
                        NULL,              
                        NULL,              
                        hInstance,         
                        NULL               
                      );

   if ( !hWnd ) 
      return( FALSE );

   ShowWindow( hWnd, nCmdShow ); 
   UpdateWindow( hWnd );         

   while( GetMessage( &msg, NULL, 0, 0) )   
   {
      TranslateMessage( &msg ); 
      DispatchMessage( &msg );  
   }

   return( msg.wParam ); 
}


#define OUR_EXCEPTION  0xE0000001

LONG WINAPI OurUnhandledExceptionFilter(LPEXCEPTION_POINTERS lpExceptionData)
{
   EXCEPTION_RECORD *ExceptionRecord = lpExceptionData->ExceptionRecord;
   CONTEXT *ContextRecord = lpExceptionData->ContextRecord;

   if (ExceptionRecord->ExceptionCode==OUR_EXCEPTION)
   {
      MessageBox( NULL, "Trapped raised exception", "Unhandled Exception Filter", MB_OK );
      return EXCEPTION_EXECUTE_HANDLER;
   }
   else
      return EXCEPTION_CONTINUE_SEARCH;
}


LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
   switch( uMsg )  
   {   
      case WM_COMMAND :
              switch( LOWORD( wParam ) )
              {
                 case IDM_TEST:
                        {
                           TCHAR szBuffer[128];
                           HDC hDC = GetDC( hWnd );

                           // Set unhandled exception handler.
                           //.................................
                           SetUnhandledExceptionFilter(OurUnhandledExceptionFilter);

                           // Raise exception try block.
                           //...........................
                           __try
                           {
                              wsprintf( szBuffer, "Raising OUR_EXCEPTION first time" );
                              MessageBox( hWnd, szBuffer, "Try Block", MB_OK );
                              RaiseException(OUR_EXCEPTION, 0, 0, NULL);
                           }
                           __except( GetExceptionCode() == OUR_EXCEPTION )
                           {
                              wsprintf( szBuffer, "Trapped OUR_EXCEPTION in normal filter" );
                              MessageBox( hWnd, szBuffer, "Except Block", MB_OK );
                           }

                           // Raise exception again using unhandled exception filter.
                           //........................................................
                           __try
                           {
                              wsprintf( szBuffer, "Raising OUR_EXCEPTION second time" );
                              MessageBox( hWnd, szBuffer, "Try Block", MB_OK );
                              RaiseException(OUR_EXCEPTION, 0, 0, NULL);
                           }
                           __except ( UnhandledExceptionFilter(GetExceptionInformation()) )
                           {
                              wsprintf( szBuffer, "Execution of except block for OUR_EXCEPTION." );
                              MessageBox( hWnd, szBuffer, "Except Block", MB_OK );
                           }

                           ReleaseDC(hWnd, hDC);
                        }
                        break;

                 case IDM_ABOUT :
                        DialogBox( hInst, "AboutBox", hWnd, (DLGPROC)About );
                        break;

                 case IDM_EXIT :
                        DestroyWindow( hWnd );
                        break;
              }
              break;
      
      case WM_DESTROY :
              PostQuitMessage(0);
              break;

      default :
            return( DefWindowProc( hWnd, uMsg, wParam, lParam ) );
   }

   return( 0L );
}


LRESULT CALLBACK About( HWND hDlg,           
                        UINT message,        
                        WPARAM wParam,       
                        LPARAM lParam)
{
   switch (message) 
   {
       case WM_INITDIALOG: 
               return (TRUE);

       case WM_COMMAND:                              
               if (   LOWORD(wParam) == IDOK         
                   || LOWORD(wParam) == IDCANCEL)    
               {
                       EndDialog(hDlg, TRUE);        
                       return (TRUE);
               }
               break;
   }

   return (FALSE); 
}
