
#include <windows.h>  
#include "TlsAlloc.h" 


HINSTANCE hInst;   // current instance

LPCTSTR lpszAppName  = "MyApp";
LPCTSTR lpszTitle    = "My Application"; 


int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                      LPTSTR lpCmdLine, int nCmdShow)
{
   MSG        msg;
   HWND       hWnd; 
   WNDCLASSEX wc;

   // Register the main application window class.
   //............................................
   wc.style         = CS_HREDRAW | CS_VREDRAW;
   wc.lpfnWndProc   = (WNDPROC)WndProc;       
   wc.cbClsExtra    = 0;                      
   wc.cbWndExtra    = 0;                      
   wc.hInstance     = hInstance;              
   wc.hIcon         = LoadIcon( hInstance, lpszAppName ); 
   wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
   wc.lpszMenuName  = lpszAppName;              
   wc.lpszClassName = lpszAppName;              
   wc.cbSize        = sizeof(WNDCLASSEX);
   wc.hIconSm       = LoadImage( hInstance, lpszAppName, 
                                 IMAGE_ICON, 16, 16,
                                 LR_DEFAULTCOLOR );

   if ( !RegisterClassEx( &wc ) )
      return( FALSE );

   hInst = hInstance; 

   // Create the main application window.
   //....................................
   hWnd = CreateWindow( lpszAppName, 
                        lpszTitle,    
                        WS_OVERLAPPEDWINDOW, 
                        CW_USEDEFAULT, 0, 
                        CW_USEDEFAULT, 0,  
                        NULL,              
                        NULL,              
                        hInstance,         
                        NULL               
                      );

   if ( !hWnd ) 
      return( FALSE );

   ShowWindow( hWnd, nCmdShow ); 
   UpdateWindow( hWnd );         

   while( GetMessage( &msg, NULL, 0, 0) )   
   {
      TranslateMessage( &msg ); 
      DispatchMessage( &msg );  
   }

   return( msg.wParam ); 
}


DWORD TLSIndex = 0;
BOOL  fAbort;

VOID ShowRunningThread( HWND hWnd )
{
   HDC hDC = GetDC( hWnd );
   TextOut(hDC, 0, 0, TlsGetValue( TLSIndex ), lstrlen( TlsGetValue( TLSIndex ) ) );
   ReleaseDC( hWnd, hDC );
}


DWORD WINAPI ThreadProc( LPDWORD lpdwData )
{
   HWND hWnd = (HWND)lpdwData;
   LPVOID lpVoid = HeapAlloc( GetProcessHeap(), 0, 128 );

   wsprintf( lpVoid, "Instance %8lx is now running.   ", GetCurrentThreadId() );
   TlsSetValue( TLSIndex, lpVoid );

   while ( !fAbort )
   {
      Sleep( 500 );
      ShowRunningThread( hWnd );
      Sleep( 0 );
   }
   HeapFree( GetProcessHeap(), 0, lpVoid );

   return( 0 );
}


LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
   switch( uMsg )  
   {   
      case WM_CREATE:
              TLSIndex = TlsAlloc();
              break;

      case WM_DESTROY:
              TlsFree( TLSIndex );
              PostQuitMessage( 0 );
              break;

      case WM_COMMAND :
              switch( LOWORD( wParam ) )
              {
                 case IDM_TEST:
                        {
                           int i;
                           HANDLE hThreads[4];  // Array of threads to wait for.
                           DWORD dwChildID;     // Child ID - discarded.

                           fAbort = FALSE;

                           for (i=0; i<4; i++)
                              hThreads[i] = CreateThread( NULL, 0, ThreadProc,
                                                          hWnd, 0, &dwChildID );
                           // Wait half a minute.
                           //....................
                           WaitForMultipleObjects( 4, hThreads, TRUE, 28000 );
                           fAbort = TRUE;
                           WaitForMultipleObjects( 4, hThreads, TRUE, 2000 );

                           // Clean screen.
                           //..............
                           InvalidateRect( hWnd, NULL, TRUE );
                           UpdateWindow( hWnd );
                        }
                        break;

                 case IDM_ABOUT :
                        DialogBox( hInst, "AboutBox", hWnd, (DLGPROC)About );
                        break;

                 case IDM_EXIT :
                        DestroyWindow( hWnd );
                        break;
              }
              break;

      default :
            return( DefWindowProc( hWnd, uMsg, wParam, lParam ) );
   }

   return( 0L );
}


LRESULT CALLBACK About( HWND hDlg,           
                        UINT message,        
                        WPARAM wParam,       
                        LPARAM lParam)
{
   switch (message) 
   {
       case WM_INITDIALOG: 
               return (TRUE);

       case WM_COMMAND:                              
               if (   LOWORD(wParam) == IDOK         
                   || LOWORD(wParam) == IDCANCEL)    
               {
                       EndDialog(hDlg, TRUE);        
                       return (TRUE);
               }
               break;
   }

   return (FALSE); 
}
