
#include <windows.h>  
#include "WaitSObj.h" 


HINSTANCE hInst;   // current instance

LPCTSTR lpszAppName  = "MyApp";
LPCTSTR lpszTitle    = "My Application"; 


int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                      LPTSTR lpCmdLine, int nCmdShow)
{
   MSG        msg;
   HWND       hWnd; 
   WNDCLASSEX wc;

   // Register the main application window class.
   //............................................
   wc.style         = CS_HREDRAW | CS_VREDRAW;
   wc.lpfnWndProc   = (WNDPROC)WndProc;       
   wc.cbClsExtra    = 0;                      
   wc.cbWndExtra    = 0;                      
   wc.hInstance     = hInstance;              
   wc.hIcon         = LoadIcon( hInstance, lpszAppName ); 
   wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
   wc.lpszMenuName  = lpszAppName;              
   wc.lpszClassName = lpszAppName;              
   wc.cbSize        = sizeof(WNDCLASSEX);
   wc.hIconSm       = LoadImage( hInstance, lpszAppName, 
                                 IMAGE_ICON, 16, 16,
                                 LR_DEFAULTCOLOR );

   if ( !RegisterClassEx( &wc ) )
      return( FALSE );

   hInst = hInstance; 

   // Create the main application window.
   //....................................
   hWnd = CreateWindow( lpszAppName, 
                        lpszTitle,    
                        WS_OVERLAPPEDWINDOW, 
                        CW_USEDEFAULT, 0, 
                        CW_USEDEFAULT, 0,  
                        NULL,              
                        NULL,              
                        hInstance,         
                        NULL               
                      );

   if ( !hWnd ) 
      return( FALSE );

   ShowWindow( hWnd, nCmdShow ); 
   UpdateWindow( hWnd );         

   while( GetMessage( &msg, NULL, 0, 0) )   
   {
      TranslateMessage( &msg ); 
      DispatchMessage( &msg );  
   }

   return( msg.wParam ); 
}


DWORD WINAPI ChildThreadProc( LPDWORD lpdwData )
{
   TCHAR szBuffer[256];
   HWND  hWnd        = (HWND)lpdwData;
   HANDLE hAutoEvent = OpenEvent( SYNCHRONIZE, FALSE, "EXAMPLE-AUTOEVENT");

   wsprintf( szBuffer, "Thread %x waiting for Event %x",
            GetCurrentThreadId(), hAutoEvent );
   SendMessage( hWnd, WM_USER, 0, (LPARAM)szBuffer );

   // Check that write auto reset is signaled.
   //.........................................
   WaitForSingleObject( hAutoEvent, INFINITE );
   wsprintf( szBuffer,"Thread %x got event", GetCurrentThreadId() );
   SendMessage( hWnd, WM_USER, 0, (LPARAM)szBuffer );
   Sleep( 5000 );

   // Release event.
   //...............
   wsprintf( szBuffer,"Thread %x is done with event", GetCurrentThreadId() );
   SendMessage( hWnd, WM_USER, 0, (LPARAM)szBuffer );
   SetEvent( hAutoEvent );
   CloseHandle( hAutoEvent );

   return( 0 );
}


LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
   static HANDLE hAutoEvent = NULL;

   switch( uMsg )  
   {   
      case WM_CREATE :
              hAutoEvent = CreateEvent( NULL, FALSE, TRUE, "EXAMPLE-AUTOEVENT");
              break;

      case WM_DESTROY :
              if ( hAutoEvent )
                 CloseHandle( hAutoEvent );

              PostQuitMessage(0);
              break;

      case WM_USER:
              {  
                 // Message to show synchronization actions.
                 TCHAR szBuffer[101];
                 static int row = 0;
                 static int msg_num = 1;
                 HDC hDC = GetDC( hWnd );

                 FillMemory( szBuffer, 100, 32 );
                 TextOut( hDC, 0, row, szBuffer, 100 );
                 wsprintf( szBuffer, "%3d: %s", msg_num++, (LPTSTR)lParam );
                 TextOut( hDC, 0, row, szBuffer, lstrlen( szBuffer ) );

                 row = ( row > 200 ) ? 0 : (row += 20);
                 ReleaseDC( hWnd, hDC );
              }
              break;

      case WM_COMMAND :
              switch( LOWORD( wParam ) )
              {
                 case IDM_TEST:
                        {
                           DWORD id = 0;
                           CreateThread( NULL, 0, ChildThreadProc, hWnd, 0, &id );
                        }
                        break;

                 case IDM_ABOUT :
                        DialogBox( hInst, "AboutBox", hWnd, (DLGPROC)About );
                        break;

                 case IDM_EXIT :
                        DestroyWindow( hWnd );
                        break;
              }
              break;
      
      default :
            return( DefWindowProc( hWnd, uMsg, wParam, lParam ) );
   }

   return( 0L );
}


LRESULT CALLBACK About( HWND hDlg,           
                        UINT message,        
                        WPARAM wParam,       
                        LPARAM lParam)
{
   switch (message) 
   {
       case WM_INITDIALOG: 
               return (TRUE);

       case WM_COMMAND:                              
               if (   LOWORD(wParam) == IDOK         
                   || LOWORD(wParam) == IDCANCEL)    
               {
                       EndDialog(hDlg, TRUE);        
                       return (TRUE);
               }
               break;
   }

   return (FALSE); 
}
